---
title: llarp::EndpointBase

---

# llarp::EndpointBase





Inherited by [llarp::service::Endpoint](Classes/structllarp_1_1service_1_1Endpoint.md)

## Public Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[QUICMappingInfo](Classes/structllarp_1_1EndpointBase_1_1QUICMappingInfo.md)** <br>info about a quic mapping  |
| struct | **[SendStat](Classes/structllarp_1_1EndpointBase_1_1SendStat.md)**  |

## Public Types

|                | Name           |
| -------------- | -------------- |
| using std::variant< [service::Address](Classes/structllarp_1_1service_1_1Address.md), [RouterID](Classes/structllarp_1_1RouterID.md) > | **[AddressVariant_t](Classes/classllarp_1_1EndpointBase.md#using-addressvariant-t)**  |

## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual | **[~EndpointBase](Classes/classllarp_1_1EndpointBase.md#function-~endpointbase)**() =default |
| std::optional< [QUICMappingInfo](Classes/structllarp_1_1EndpointBase_1_1QUICMappingInfo.md) > | **[GetQUICMappingInfoByID](Classes/classllarp_1_1EndpointBase.md#function-getquicmappinginfobyid)**(int stream_id) const<br>maybe get quic mapping info given its stream id returns std::nullopt if we have no stream given that id  |
| void | **[PutSRVRecord](Classes/classllarp_1_1EndpointBase.md#function-putsrvrecord)**([dns::SRVData](Classes/classllarp_1_1dns_1_1SRVData.md) srv)<br>add an srv record to this endpoint's descriptor  |
| virtual std::shared_ptr< [dns::Server](Classes/classllarp_1_1dns_1_1Server.md) > | **[DNS](Classes/classllarp_1_1EndpointBase.md#function-dns)**() const<br>get dns serverr if we have on on this endpoint  |
| virtual void | **[SRVRecordsChanged](Classes/classllarp_1_1EndpointBase.md#function-srvrecordschanged)**() =0<br>called when srv data changes in some way  |
| bool | **[DelSRVRecordIf](Classes/classllarp_1_1EndpointBase.md#function-delsrvrecordif)**(std::function< bool(const [dns::SRVData](Classes/classllarp_1_1dns_1_1SRVData.md) &)> filter)<br>remove srv records from this endpoint that match a filter for each srv record call it with filter, remove if filter returns true return if we removed any srv records  |
| std::set< [dns::SRVData](Classes/classllarp_1_1dns_1_1SRVData.md) > | **[SRVRecords](Classes/classllarp_1_1EndpointBase.md#function-srvrecords)**() const<br>get copy of all srv records  |
| virtual std::optional< [SendStat](Classes/structllarp_1_1EndpointBase_1_1SendStat.md) > | **[GetStatFor](Classes/classllarp_1_1EndpointBase.md#function-getstatfor)**(AddressVariant_t remote) const =0<br>get statistics about how much traffic we sent and recv'd to a remote endpoint  |
| virtual std::unordered_set< AddressVariant_t > | **[AllRemoteEndpoints](Classes/classllarp_1_1EndpointBase.md#function-allremoteendpoints)**() const =0<br>list all remote endpoint addresses we have that are mapped  |
| virtual AddressVariant_t | **[LocalAddress](Classes/classllarp_1_1EndpointBase.md#function-localaddress)**() const =0<br>get our local address  |
| virtual [quic::TunnelManager](Classes/classllarp_1_1quic_1_1TunnelManager.md) * | **[GetQUICTunnel](Classes/classllarp_1_1EndpointBase.md#function-getquictunnel)**() =0 |
| virtual std::optional< AddressVariant_t > | **[GetEndpointWithConvoTag](Classes/classllarp_1_1EndpointBase.md#function-getendpointwithconvotag)**([service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) tag) const =0 |
| virtual std::optional< [service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) > | **[GetBestConvoTagFor](Classes/classllarp_1_1EndpointBase.md#function-getbestconvotagfor)**(AddressVariant_t addr) const =0 |
| virtual bool | **[EnsurePathTo](Classes/classllarp_1_1EndpointBase.md#function-ensurepathto)**(AddressVariant_t addr, std::function< void(std::optional< [service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) >)> hook, llarp_time_t timeout) =0<br>MUST call MarkAddressOutbound first if we are initiating the flow to the remote.  |
| virtual void | **[LookupNameAsync](Classes/classllarp_1_1EndpointBase.md#function-lookupnameasync)**(std::string name, std::function< void(std::optional< AddressVariant_t >)> resultHandler) =0 |
| virtual bool | **[LookupRC](Classes/classllarp_1_1EndpointBase.md#function-lookuprc)**([RouterID](Classes/structllarp_1_1RouterID.md) rid, RouterLookupHandler handler) =0 |
| virtual const EventLoop_ptr & | **[Loop](Classes/classllarp_1_1EndpointBase.md#function-loop)**() =0 |
| virtual bool | **[SendToOrQueue](Classes/classllarp_1_1EndpointBase.md#function-sendtoorqueue)**([service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) tag, std::vector< byte_t > data, service::ProtocolType t) =0 |
| bool | **[SendToOrQueue](Classes/classllarp_1_1EndpointBase.md#function-sendtoorqueue)**([service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) tag, const [llarp_buffer_t](Classes/structllarp__buffer__t.md) & payload, service::ProtocolType t) |
| virtual void | **[LookupServiceAsync](Classes/classllarp_1_1EndpointBase.md#function-lookupserviceasync)**(std::string name, std::string service, std::function< void(std::vector< [dns::SRVData](Classes/classllarp_1_1dns_1_1SRVData.md) >)> resultHandler) =0<br>lookup srv records async  |
| virtual void | **[MarkAddressOutbound](Classes/classllarp_1_1EndpointBase.md#function-markaddressoutbound)**(AddressVariant_t remote) =0<br>will mark a remote as something we want to initiate a flow to.  |
| virtual bool | **[Configure](Classes/classllarp_1_1EndpointBase.md#function-configure)**(const [NetworkConfig](Classes/structllarp_1_1NetworkConfig.md) & ) =0 |
| virtual std::string_view | **[endpoint_name](Classes/classllarp_1_1EndpointBase.md#function-endpoint-name)**() const =0 |
| virtual void | **[start_endpoint](Classes/classllarp_1_1EndpointBase.md#function-start-endpoint)**()<br>called to do any deferred startup items after configure.  |
| virtual void | **[stop_endpoint](Classes/classllarp_1_1EndpointBase.md#function-stop-endpoint)**()<br>initiate shutdown of all periodic operations.  |
| virtual void | **[periodic_tick](Classes/classllarp_1_1EndpointBase.md#function-periodic-tick)**()<br>called in a periodic event loop timer.  |
| virtual void | **[event_loop_pump](Classes/classllarp_1_1EndpointBase.md#function-event-loop-pump)**()<br>called in an idempotent event loop handler after reading io each tick.  |

## Public Types Documentation

### using AddressVariant_t

```cpp
using llarp::EndpointBase::AddressVariant_t =  std::variant<service::Address, RouterID>;
```


## Public Functions Documentation

### function ~EndpointBase

```cpp
virtual ~EndpointBase() =default
```


### function GetQUICMappingInfoByID

```cpp
std::optional< QUICMappingInfo > GetQUICMappingInfoByID(
    int stream_id
) const
```

maybe get quic mapping info given its stream id returns std::nullopt if we have no stream given that id 

### function PutSRVRecord

```cpp
void PutSRVRecord(
    dns::SRVData srv
)
```

add an srv record to this endpoint's descriptor 

### function DNS

```cpp
inline virtual std::shared_ptr< dns::Server > DNS() const
```

get dns serverr if we have on on this endpoint 

### function SRVRecordsChanged

```cpp
virtual void SRVRecordsChanged() =0
```

called when srv data changes in some way 

**Reimplemented by**: [llarp::service::Endpoint::SRVRecordsChanged](Classes/structllarp_1_1service_1_1Endpoint.md#function-srvrecordschanged)


### function DelSRVRecordIf

```cpp
bool DelSRVRecordIf(
    std::function< bool(const dns::SRVData &)> filter
)
```

remove srv records from this endpoint that match a filter for each srv record call it with filter, remove if filter returns true return if we removed any srv records 

### function SRVRecords

```cpp
std::set< dns::SRVData > SRVRecords() const
```

get copy of all srv records 

### function GetStatFor

```cpp
virtual std::optional< SendStat > GetStatFor(
    AddressVariant_t remote
) const =0
```

get statistics about how much traffic we sent and recv'd to a remote endpoint 

**Reimplemented by**: [llarp::service::Endpoint::GetStatFor](Classes/structllarp_1_1service_1_1Endpoint.md#function-getstatfor)


### function AllRemoteEndpoints

```cpp
virtual std::unordered_set< AddressVariant_t > AllRemoteEndpoints() const =0
```

list all remote endpoint addresses we have that are mapped 

**Reimplemented by**: [llarp::service::Endpoint::AllRemoteEndpoints](Classes/structllarp_1_1service_1_1Endpoint.md#function-allremoteendpoints)


### function LocalAddress

```cpp
virtual AddressVariant_t LocalAddress() const =0
```

get our local address 

**Reimplemented by**: [llarp::service::Endpoint::LocalAddress](Classes/structllarp_1_1service_1_1Endpoint.md#function-localaddress)


### function GetQUICTunnel

```cpp
virtual quic::TunnelManager * GetQUICTunnel() =0
```


**Reimplemented by**: [llarp::service::Endpoint::GetQUICTunnel](Classes/structllarp_1_1service_1_1Endpoint.md#function-getquictunnel)


### function GetEndpointWithConvoTag

```cpp
virtual std::optional< AddressVariant_t > GetEndpointWithConvoTag(
    service::ConvoTag tag
) const =0
```


**Reimplemented by**: [llarp::service::Endpoint::GetEndpointWithConvoTag](Classes/structllarp_1_1service_1_1Endpoint.md#function-getendpointwithconvotag)


### function GetBestConvoTagFor

```cpp
virtual std::optional< service::ConvoTag > GetBestConvoTagFor(
    AddressVariant_t addr
) const =0
```


### function EnsurePathTo

```cpp
virtual bool EnsurePathTo(
    AddressVariant_t addr,
    std::function< void(std::optional< service::ConvoTag >)> hook,
    llarp_time_t timeout
) =0
```

MUST call MarkAddressOutbound first if we are initiating the flow to the remote. 

### function LookupNameAsync

```cpp
virtual void LookupNameAsync(
    std::string name,
    std::function< void(std::optional< AddressVariant_t >)> resultHandler
) =0
```


### function LookupRC

```cpp
virtual bool LookupRC(
    RouterID rid,
    RouterLookupHandler handler
) =0
```


**Reimplemented by**: [llarp::service::Endpoint::LookupRC](Classes/structllarp_1_1service_1_1Endpoint.md#function-lookuprc)


### function Loop

```cpp
virtual const EventLoop_ptr & Loop() =0
```


**Reimplemented by**: [llarp::service::Endpoint::Loop](Classes/structllarp_1_1service_1_1Endpoint.md#function-loop)


### function SendToOrQueue

```cpp
virtual bool SendToOrQueue(
    service::ConvoTag tag,
    std::vector< byte_t > data,
    service::ProtocolType t
) =0
```


**Reimplemented by**: [llarp::service::Endpoint::SendToOrQueue](Classes/structllarp_1_1service_1_1Endpoint.md#function-sendtoorqueue)


### function SendToOrQueue

```cpp
inline bool SendToOrQueue(
    service::ConvoTag tag,
    const llarp_buffer_t & payload,
    service::ProtocolType t
)
```


### function LookupServiceAsync

```cpp
virtual void LookupServiceAsync(
    std::string name,
    std::string service,
    std::function< void(std::vector< dns::SRVData >)> resultHandler
) =0
```

lookup srv records async 

**Reimplemented by**: [llarp::service::Endpoint::LookupServiceAsync](Classes/structllarp_1_1service_1_1Endpoint.md#function-lookupserviceasync)


### function MarkAddressOutbound

```cpp
virtual void MarkAddressOutbound(
    AddressVariant_t remote
) =0
```

will mark a remote as something we want to initiate a flow to. 

**Reimplemented by**: [llarp::service::Endpoint::MarkAddressOutbound](Classes/structllarp_1_1service_1_1Endpoint.md#function-markaddressoutbound)


making this explicit prevents us from doing weird things when we are the recipient. 


### function Configure

```cpp
virtual bool Configure(
    const NetworkConfig & 
) =0
```


**Reimplemented by**: [llarp::service::Endpoint::Configure](Classes/structllarp_1_1service_1_1Endpoint.md#function-configure)


### function endpoint_name

```cpp
virtual std::string_view endpoint_name() const =0
```


**Reimplemented by**: [llarp::service::Endpoint::endpoint_name](Classes/structllarp_1_1service_1_1Endpoint.md#function-endpoint-name)


### function start_endpoint

```cpp
inline virtual void start_endpoint()
```

called to do any deferred startup items after configure. 

### function stop_endpoint

```cpp
inline virtual void stop_endpoint()
```

initiate shutdown of all periodic operations. 

### function periodic_tick

```cpp
inline virtual void periodic_tick()
```

called in a periodic event loop timer. 

### function event_loop_pump

```cpp
inline virtual void event_loop_pump()
```

called in an idempotent event loop handler after reading io each tick. 

-------------------------------

Updated on 2023-03-14 at 14:02:05 +0000