---
title: llarp::layers::flow::FlowState_Base
summary: internal state of a flow on the flow layer. 

---

# llarp::layers::flow::FlowState_Base



internal state of a flow on the flow layer. 


`#include <flow_state.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[FlowState_Base](Classes/classllarp_1_1layers_1_1flow_1_1FlowState__Base.md#function-flowstate-base)**(const [FlowState_Base](Classes/classllarp_1_1layers_1_1flow_1_1FlowState__Base.md) & ) =delete |
| | **[FlowState_Base](Classes/classllarp_1_1layers_1_1flow_1_1FlowState__Base.md#function-flowstate-base)**([FlowState_Base](Classes/classllarp_1_1layers_1_1flow_1_1FlowState__Base.md) && ) =delete |
| bool | **[paths_aligned](Classes/classllarp_1_1layers_1_1flow_1_1FlowState__Base.md#function-paths-aligned)**() const<br>returns true if we have paths that are aligned to the right place on the network to send to the remote.  |
| bool | **[requires_authentication](Classes/classllarp_1_1layers_1_1flow_1_1FlowState__Base.md#function-requires-authentication)**() const<br>returns true if we are to do authentication with the remote.  |
| FlowAuthPhase | **[auth_phase](Classes/classllarp_1_1layers_1_1flow_1_1FlowState__Base.md#function-auth-phase)**() const<br>get the phase we are in with auth.  |
| bool | **[established](Classes/classllarp_1_1layers_1_1flow_1_1FlowState__Base.md#function-established)**() const<br>returns true if we have an established session for sending traffic over to the remote.  |

## Public Functions Documentation

### function FlowState_Base

```cpp
FlowState_Base(
    const FlowState_Base & 
) =delete
```


### function FlowState_Base

```cpp
FlowState_Base(
    FlowState_Base && 
) =delete
```


### function paths_aligned

```cpp
bool paths_aligned() const
```

returns true if we have paths that are aligned to the right place on the network to send to the remote. 

### function requires_authentication

```cpp
bool requires_authentication() const
```

returns true if we are to do authentication with the remote. 

### function auth_phase

```cpp
FlowAuthPhase auth_phase() const
```

get the phase we are in with auth. 

### function established

```cpp
bool established() const
```

returns true if we have an established session for sending traffic over to the remote. 

any authentication has completed and accepted. 


-------------------------------

Updated on 2023-03-14 at 14:02:05 +0000