---
title: llarp::dns::Message

---

# llarp::dns::Message





## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[Message](Classes/structllarp_1_1dns_1_1Message.md#function-message)**([bstring_view](Namespaces/namespacellarp.md#using-bstring-view) & raw)<br>constructs a dns message from a raw dns wire protocol message.  |
| | **[Message](Classes/structllarp_1_1dns_1_1Message.md#function-message)**() =default |
| | **[Message](Classes/structllarp_1_1dns_1_1Message.md#function-message)**(const [Message](Classes/structllarp_1_1dns_1_1Message.md) & ) =default |
| | **[Message](Classes/structllarp_1_1dns_1_1Message.md#function-message)**([Message](Classes/structllarp_1_1dns_1_1Message.md) && ) =default |
| [Message](Classes/structllarp_1_1dns_1_1Message.md) & | **[operator=](Classes/structllarp_1_1dns_1_1Message.md#function-operator=)**(const [Message](Classes/structllarp_1_1dns_1_1Message.md) & ) =default |
| [Message](Classes/structllarp_1_1dns_1_1Message.md) & | **[operator=](Classes/structllarp_1_1dns_1_1Message.md#function-operator=)**([Message](Classes/structllarp_1_1dns_1_1Message.md) && ) =default |
| [Message](Classes/structllarp_1_1dns_1_1Message.md) & | **[nx](Classes/structllarp_1_1dns_1_1Message.md#function-nx)**()<br>mark as not found.  |
| [Message](Classes/structllarp_1_1dns_1_1Message.md) & | **[servfail](Classes/structllarp_1_1dns_1_1Message.md#function-servfail)**()<br>mark as servfail.  |
| [bstring](Namespaces/namespacellarp.md#using-bstring) | **[encode_dns](Classes/structllarp_1_1dns_1_1Message.md#function-encode-dns)**() const<br>encodes this dns message to dns wire protocol.  |
| util::StatusObject | **[to_json](Classes/structllarp_1_1dns_1_1Message.md#function-to-json)**() const |
| [OwnedBuffer](Classes/structllarp_1_1OwnedBuffer.md) | **[ToBuffer](Classes/structllarp_1_1dns_1_1Message.md#function-tobuffer)**() const |
| std::string | **[ToString](Classes/structllarp_1_1dns_1_1Message.md#function-tostring)**() const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| [MessageHeader](Classes/structllarp_1_1dns_1_1MessageHeader.md) | **[hdr](Classes/structllarp_1_1dns_1_1Message.md#variable-hdr)**  |
| std::vector< [Question](Classes/structllarp_1_1dns_1_1Question.md) > | **[questions](Classes/structllarp_1_1dns_1_1Message.md#variable-questions)**  |
| std::vector< [ResourceRecord](Classes/structllarp_1_1dns_1_1ResourceRecord.md) > | **[answers](Classes/structllarp_1_1dns_1_1Message.md#variable-answers)**  |
| std::vector< [ResourceRecord](Classes/structllarp_1_1dns_1_1ResourceRecord.md) > | **[authorities](Classes/structllarp_1_1dns_1_1Message.md#variable-authorities)**  |
| std::vector< [ResourceRecord](Classes/structllarp_1_1dns_1_1ResourceRecord.md) > | **[additional](Classes/structllarp_1_1dns_1_1Message.md#variable-additional)**  |

## Public Functions Documentation

### function Message

```cpp
explicit Message(
    bstring_view & raw
)
```

constructs a dns message from a raw dns wire protocol message. 

raw is modified to contain any remaining data. 


### function Message

```cpp
Message() =default
```


### function Message

```cpp
Message(
    const Message & 
) =default
```


### function Message

```cpp
Message(
    Message && 
) =default
```


### function operator=

```cpp
Message & operator=(
    const Message & 
) =default
```


### function operator=

```cpp
Message & operator=(
    Message && 
) =default
```


### function nx

```cpp
Message & nx()
```

mark as not found. 

### function servfail

```cpp
Message & servfail()
```

mark as servfail. 

### function encode_dns

```cpp
bstring encode_dns() const
```

encodes this dns message to dns wire protocol. 

### function to_json

```cpp
util::StatusObject to_json() const
```


### function ToBuffer

```cpp
inline OwnedBuffer ToBuffer() const
```


### function ToString

```cpp
std::string ToString() const
```


## Public Attributes Documentation

### variable hdr

```cpp
MessageHeader hdr;
```


### variable questions

```cpp
std::vector< Question > questions;
```


### variable answers

```cpp
std::vector< ResourceRecord > answers;
```


### variable authorities

```cpp
std::vector< ResourceRecord > authorities;
```


### variable additional

```cpp
std::vector< ResourceRecord > additional;
```


-------------------------------

Updated on 2023-03-14 at 14:02:05 +0000