---
title: llarp::routing::ObtainExitMessage

---

# llarp::routing::ObtainExitMessage





Inherits from [llarp::routing::IMessage](Classes/structllarp_1_1routing_1_1IMessage.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[ObtainExitMessage](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#function-obtainexitmessage)**() |
| | **[~ObtainExitMessage](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#function-~obtainexitmessage)**() override =default |
| virtual void | **[Clear](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#function-clear)**() override |
| bool | **[Sign](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#function-sign)**(const [llarp::SecretKey](Classes/structllarp_1_1SecretKey.md) & sk)<br>populates I and signs  |
| bool | **[Verify](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#function-verify)**() const |
| virtual bool | **[BEncode](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#function-bencode)**([llarp_buffer_t](Classes/structllarp__buffer__t.md) * buf) const override |
| virtual bool | **[DecodeKey](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#function-decodekey)**(const [llarp_buffer_t](Classes/structllarp__buffer__t.md) & key, [llarp_buffer_t](Classes/structllarp__buffer__t.md) * buf) override |
| virtual bool | **[HandleMessage](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#function-handlemessage)**([IMessageHandler](Classes/structllarp_1_1routing_1_1IMessageHandler.md) * h, [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) * r) const override |
| std::string | **[ToString](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#function-tostring)**() const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| std::vector< [llarp::exit::Policy](Classes/structllarp_1_1exit_1_1Policy.md) > | **[blacklist](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-blacklist)**  |
| uint64_t | **[wants_exit](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-wants-exit)**  |
| [llarp::PubKey](Classes/structllarp_1_1PubKey.md) | **[source_identity](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-source-identity)**  |
| uint64_t | **[txid](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-txid)**  |
| std::vector< [llarp::exit::Policy](Classes/structllarp_1_1exit_1_1Policy.md) > | **[whitelist](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-whitelist)**  |
| uint64_t | **[request_expires_at](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-request-expires-at)**  |
| [llarp::Signature](Classes/structllarp_1_1Signature.md) | **[sig](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-sig)**  |
| decltype(blacklist) & | **[B](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-b)**  |
| decltype(wants_exit) & | **[E](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-e)**  |
| decltype(source_identity) & | **[I](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-i)**  |
| decltype(txid) & | **[T](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-t)**  |
| decltype(whitelist) & | **[W](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-w)**  |
| decltype(request_expires_at) & | **[X](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-x)**  |
| decltype(sig) & | **[Z](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md#variable-z)**  |

## Additional inherited members

**Public Functions inherited from [llarp::routing::IMessage](Classes/structllarp_1_1routing_1_1IMessage.md)**

|                | Name           |
| -------------- | -------------- |
| | **[IMessage](Classes/structllarp_1_1routing_1_1IMessage.md#function-imessage)**() =default |
| virtual | **[~IMessage](Classes/structllarp_1_1routing_1_1IMessage.md#function-~imessage)**() =default |
| bool | **[operator<](Classes/structllarp_1_1routing_1_1IMessage.md#function-operator<)**(const [IMessage](Classes/structllarp_1_1routing_1_1IMessage.md) & other) const |

**Public Attributes inherited from [llarp::routing::IMessage](Classes/structllarp_1_1routing_1_1IMessage.md)**

|                | Name           |
| -------------- | -------------- |
| [PathID_t](Classes/structllarp_1_1PathID__t.md) | **[from](Classes/structllarp_1_1routing_1_1IMessage.md#variable-from)**  |
| uint64_t | **[S](Classes/structllarp_1_1routing_1_1IMessage.md#variable-s)**  |
| uint64_t | **[version](Classes/structllarp_1_1routing_1_1IMessage.md#variable-version)**  |


## Public Functions Documentation

### function ObtainExitMessage

```cpp
inline ObtainExitMessage()
```


### function ~ObtainExitMessage

```cpp
~ObtainExitMessage() override =default
```


### function Clear

```cpp
inline virtual void Clear() override
```


**Reimplements**: [llarp::routing::IMessage::Clear](Classes/structllarp_1_1routing_1_1IMessage.md#function-clear)


### function Sign

```cpp
bool Sign(
    const llarp::SecretKey & sk
)
```

populates I and signs 

### function Verify

```cpp
bool Verify() const
```


### function BEncode

```cpp
virtual bool BEncode(
    llarp_buffer_t * buf
) const override
```


**Reimplements**: [llarp::routing::IMessage::BEncode](Classes/structllarp_1_1routing_1_1IMessage.md#function-bencode)


### function DecodeKey

```cpp
virtual bool DecodeKey(
    const llarp_buffer_t & key,
    llarp_buffer_t * buf
) override
```


**Reimplements**: [llarp::routing::IMessage::DecodeKey](Classes/structllarp_1_1routing_1_1IMessage.md#function-decodekey)


### function HandleMessage

```cpp
virtual bool HandleMessage(
    IMessageHandler * h,
    AbstractRouter * r
) const override
```


**Reimplements**: [llarp::routing::IMessage::HandleMessage](Classes/structllarp_1_1routing_1_1IMessage.md#function-handlemessage)


### function ToString

```cpp
std::string ToString() const
```


## Public Attributes Documentation

### variable blacklist

```cpp
std::vector< llarp::exit::Policy > blacklist;
```


### variable wants_exit

```cpp
uint64_t wants_exit {0};
```


### variable source_identity

```cpp
llarp::PubKey source_identity;
```


### variable txid

```cpp
uint64_t txid {0};
```


### variable whitelist

```cpp
std::vector< llarp::exit::Policy > whitelist;
```


### variable request_expires_at

```cpp
uint64_t request_expires_at {0};
```


### variable sig

```cpp
llarp::Signature sig;
```


### variable B

```cpp
decltype(blacklist) & B {blacklist};
```


### variable E

```cpp
decltype(wants_exit) & E {wants_exit};
```


### variable I

```cpp
decltype(source_identity) & I {source_identity};
```


### variable T

```cpp
decltype(txid) & T {txid};
```


### variable W

```cpp
decltype(whitelist) & W {whitelist};
```


### variable X

```cpp
decltype(request_expires_at) & X {request_expires_at};
```


### variable Z

```cpp
decltype(sig) & Z {sig};
```


-------------------------------

Updated on 2023-03-14 at 14:02:06 +0000