---
title: llarp/layers/flow/flow_auth.hpp

---

# llarp/layers/flow/flow_auth.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |




## Source code

```cpp
#pragma once

#include <functional>
#include <string>
#include <optional>

#include <llarp/util/formattable.hpp>
#include <string_view>

namespace llarp::layers::flow
{

  enum class FlowAuthPhase
  {
    auth_req_not_sent,
    auth_req_sent,
    auth_nack,
    auth_more,
    auth_ok,
  };
  std::string_view
  ToString(FlowAuthPhase phase);

}  // namespace llarp::layers::flow

namespace llarp
{

  template <>
  inline constexpr bool IsToStringFormattable<layers::flow::FlowAuthPhase> = true;
}  // namespace llarp
```


-------------------------------

Updated on 2023-03-14 at 14:02:06 +0000
