---
title: llarp/layers/flow/flow_data_kind.hpp

---

# llarp/layers/flow/flow_data_kind.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |




## Source code

```cpp
#pragma once
#include <llarp/util/formattable.hpp>

namespace llarp::layers::flow
{
  enum class FlowDataKind
  {
    unknown,
    direct_ip_unicast,
    exit_ip_unicast,
    auth,
    stream_unicast,
  };

  std::string_view
  ToString(FlowDataKind kind);
}  // namespace llarp::layers::flow

namespace llarp
{

  template <>
  inline constexpr bool IsToStringFormattable<llarp::layers::flow::FlowDataKind> = true;
}
```


-------------------------------

Updated on 2023-03-14 at 14:02:06 +0000
