---
title: llarp/layers/platform/name_cache.hpp

---

# llarp/layers/platform/name_cache.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::platform](Namespaces/namespacellarp_1_1layers_1_1platform.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::platform::NameCache](Classes/classllarp_1_1layers_1_1platform_1_1NameCache.md)** <br>cache for in network names (ONS records) with static TTL.  |




## Source code

```cpp
#pragma once

#include <llarp/layers/flow/flow_addr.hpp>
#include <llarp/util/decaying_hashtable.hpp>

namespace llarp::layers::platform
{
  class NameCache
  {
    util::DecayingHashTable<std::string, flow::FlowAddr> _names;

   public:
    NameCache(std::chrono::seconds ttl = 5min);

    std::optional<flow::FlowAddr>
    get(std::string name);

    void
    put(std::string name, flow::FlowAddr addr);
  };
}  // namespace llarp::layers::platform
```


-------------------------------

Updated on 2023-03-14 at 14:02:06 +0000
