---
title: llarp::layers::platform

---

# llarp::layers::platform



## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::layers::platform::AddressMapping](Classes/structllarp_1_1layers_1_1platform_1_1AddressMapping.md)**  |
| class | **[llarp::layers::platform::AddressMappingEntry](Classes/classllarp_1_1layers_1_1platform_1_1AddressMappingEntry.md)** <br>container that holds an addressmapping and extra metadata we need in the addrmapper.  |
| class | **[llarp::layers::platform::AddrMapper](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md)** <br>in charge of mapping flow addresses and platform addresses to each other  |
| class | **[llarp::layers::platform::DNSZone](Classes/classllarp_1_1layers_1_1platform_1_1DNSZone.md)** <br>synthesizes authoritative RR for a .loki or .snode address.  |
| class | **[llarp::layers::platform::DNSQueryHandler](Classes/classllarp_1_1layers_1_1platform_1_1DNSQueryHandler.md)** <br>handles dns queries, for .loki / .snode  |
| class | **[llarp::layers::platform::NameCache](Classes/classllarp_1_1layers_1_1platform_1_1NameCache.md)** <br>cache for in network names (ONS records) with static TTL.  |
| class | **[llarp::layers::platform::NameResolver](Classes/classllarp_1_1layers_1_1platform_1_1NameResolver.md)**  |
| struct | **[llarp::layers::platform::OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md)** <br>platfrom datum that is used to read and write to the os  |
| struct | **[llarp::layers::platform::PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md)** <br>a (ipv6 address, flowlabel) tuple that we use for platform layer side addressing  |
| class | **[llarp::layers::platform::OSTraffic_IO_Base](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md)**  |
| class | **[llarp::layers::platform::PlatformLayer](Classes/classllarp_1_1layers_1_1platform_1_1PlatformLayer.md)** <br>responsible for bridging the os and the flow layer.  |
| struct | **[llarp::layers::platform::PlatformStats](Classes/structllarp_1_1layers_1_1platform_1_1PlatformStats.md)**  |

## Types

|                | Name           |
| -------------- | -------------- |
| enum class| **[EtherType_t](Namespaces/namespacellarp_1_1layers_1_1platform.md#enum-ethertype-t)** { ip_unicast, plainquic, proto_auth}<br>the kind of traffic we are tunneling  |

## Functions

|                | Name           |
| -------------- | -------------- |
| std::string | **[ToString](Namespaces/namespacellarp_1_1layers_1_1platform.md#function-tostring)**(EtherType_t kind) |

## Types Documentation

### enum EtherType_t

| Enumerator | Value | Description |
| ---------- | ----- | ----------- |
| ip_unicast | | ipv4/ipv6 unicast traffic   |
| plainquic | | plainquic stream   |
| proto_auth | | flow layer auth protocol   |



the kind of traffic we are tunneling 


## Functions Documentation

### function ToString

```cpp
std::string ToString(
    EtherType_t kind
)
```






-------------------------------

Updated on 2023-03-14 at 14:02:05 +0000